DROP TABLE IF EXISTS `@wa_article`;
CREATE TABLE `@wa_article` (
  `article_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `category_id` int(10) unsigned NOT NULL,
  `status` tinyint(1) DEFAULT '0',
  `title` text NOT NULL,
  `content_key` varchar(255) DEFAULT '',
  `member_id` int(11) unsigned DEFAULT '0',
  `author` varchar(255) DEFAULT '',
  `copyright` varchar(255) DEFAULT '',
  `thumbs` varchar(200) DEFAULT '',
  `hits` int(10) unsigned DEFAULT '0',
  `robots` varchar(255) DEFAULT '',
  `files` text,
  `timeadd` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`article_id`),
  KEY `category_id` (`category_id`),
  KEY `member_id` (`member_id`),
  KEY `content_key` (`content_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_article_lang`;
CREATE TABLE `@wa_article_lang` (
  `article_id` int(11) unsigned NOT NULL,
  `lang` varchar(30) NOT NULL,
  `title` varchar(255) NOT NULL,
  `content` text NOT NULL,
  `translator` varchar(150) DEFAULT '',
  `meta_keywords` varchar(255) DEFAULT '',
  `meta_description` varchar(255) DEFAULT '',
  `commentid` int(15) unsigned DEFAULT '0',
  `options` text,
  `timeedit` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`article_id`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_category`;
CREATE TABLE `@wa_category` (
  `category_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parentid` int(10) unsigned DEFAULT '0',
  `status` tinyint(1) unsigned DEFAULT '1',
  `category` text NOT NULL,
  `category_key` varchar(255) DEFAULT '',
  `ordernum` mediumint(8) unsigned DEFAULT '50',
  `category_cache` mediumint(8) DEFAULT '-1',
  `content_cache` mediumint(8) DEFAULT '-1',
  `redirect` varchar(255) DEFAULT '',
  PRIMARY KEY (`category_id`),
  KEY `parentid` (`parentid`),
  KEY `ordernum` (`ordernum`),
  KEY `category_key` (`category_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_category_lang`;
CREATE TABLE `@wa_category_lang` (
  `category_id` int(10) unsigned NOT NULL,
  `lang` varchar(30) NOT NULL,
  `category` varchar(150) NOT NULL,
  `category_tpl` varchar(255) DEFAULT '',
  `content_tpl` varchar(255) DEFAULT '',
  `meta_keywords` varchar(255) DEFAULT '',
  `meta_description` varchar(255) DEFAULT '',
  `options` text,
  PRIMARY KEY (`category_id`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_comment`;
CREATE TABLE `@wa_comment` (
  `comment_id` int(15) unsigned NOT NULL AUTO_INCREMENT,
  `commentid` int(15) unsigned NOT NULL,
  `member_id` int(11) unsigned DEFAULT '0',
  `username` varchar(50) DEFAULT '',
  `comment` text NOT NULL,
  `timeadd` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`comment_id`),
  KEY `commentid` (`commentid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_cron`;
CREATE TABLE `@wa_cron` (
  `cron` varchar(80) NOT NULL,
  `title` varchar(80) NOT NULL,
  `status` tinyint(1) unsigned DEFAULT '1',
  `intervals` mediumint(8) unsigned DEFAULT '0',
  `next_run` int(10) unsigned DEFAULT '0',
  `runs` int(10) unsigned DEFAULT '0',
  `description` text,
  PRIMARY KEY (`cron`),
  KEY `status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_currency`;
CREATE TABLE `@wa_currency` (
  `currency` char(3) NOT NULL,
  `symbol` varchar(10) DEFAULT '',
  `unit` varchar(10)  DEFAULT '',
  `rate` float(10,6) unsigned NOT NULL,
  `decimals` tinyint(1) unsigned DEFAULT '2',
  PRIMARY KEY (`currency`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_member`;
CREATE TABLE `@wa_member` (
  `member_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `member_gid` smallint(4) DEFAULT '0',
  `username` varchar(50) NOT NULL,
  `password` char(32) NOT NULL,
  `status` tinyint(1) DEFAULT '0',
  `email` varchar(200) NOT NULL,
  `balance` float(15,2) DEFAULT '0.00',
  `frozen` float(15,2) unsigned DEFAULT '0.00',
  `points` int(15) unsigned DEFAULT '0',
  `usedsize` int(10) unsigned DEFAULT '0' COMMENT 'MB',
  `memship` varchar(50) DEFAULT 'default',
  `ipadd` varchar(39) DEFAULT '',
  `timeadd` int(10) unsigned DEFAULT '0',
  `ipprev` varchar(39) DEFAULT '',
  `timeprev` int(10) unsigned DEFAULT '0',
  `iplast` varchar(39) DEFAULT '',
  `timelast` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`member_id`),
  UNIQUE KEY `username` (`username`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_member_default`;
CREATE TABLE `@wa_member_default` (
  `member_id` int(11) unsigned NOT NULL,
  `firstname` varchar(50) DEFAULT '',
  `lastname` varchar(50) DEFAULT '',
  `gender` tinyint(1) unsigned DEFAULT '0',
  `country` varchar(50) DEFAULT '',
  `province` varchar(30) DEFAULT '',
  `city` varchar(30) DEFAULT '',
  `address` varchar(255) DEFAULT '',
  `telephone` varchar(50) DEFAULT '',
  `im` varchar(200) DEFAULT '',
  PRIMARY KEY (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_member_group`;
CREATE TABLE `@wa_member_group` (
  `member_gid` smallint(4) NOT NULL,
  `gname` varchar(50) NOT NULL,
  `description` varchar(255) DEFAULT '',
  `sys_perm` text,
  `mem_perm` text,
  `web_perm` text,
  `sys_limit` text,
  `mem_limit` text,
  `web_limit` text,
  PRIMARY KEY (`member_gid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@wa_member_group` VALUES ('-1', 'Banned', 'No any permission.', '', '', '', '', '', '');
INSERT INTO `@wa_member_group` VALUES ('0', 'Guest', 'All front-end permissions.Maps all unregistered visitors.', '', '', '*.*', '', '', '');
INSERT INTO `@wa_member_group` VALUES ('1', 'Registered', 'All member area and front end permissions.', '', '*.*', '*.*', '', '', '');
INSERT INTO `@wa_member_group` VALUES ('999', 'Administrator', 'Part of admin area and full other permissions.', 'basic.access', '*.*', '*.*', '', '', '');
INSERT INTO `@wa_member_group` VALUES ('9999', 'Super Admin', 'All permissions over whole site,no any limit.', '*.*', '*.*', '*.*', '', '', '');

DROP TABLE IF EXISTS `@wa_member_setting`;
CREATE TABLE `@wa_member_setting` (
  `member_id` int(11) unsigned NOT NULL,
  `my_language` varchar(30) DEFAULT '',
  `my_currency` char(3) DEFAULT '',
  `my_timezone` varchar(30) DEFAULT '',
  `my_locale` varchar(20) DEFAULT '',
  PRIMARY KEY (`member_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_plugin`;
CREATE TABLE `@wa_plugin` (
  `id` varchar(50) NOT NULL,
  `type` varchar(50) NOT NULL,
  `title` varchar(50) NOT NULL,
  `version` varchar(10) DEFAULT '',
  `creation_date` varchar(30) DEFAULT '',
  `author` varchar(100) DEFAULT '',
  `author_email` varchar(150) DEFAULT '',
  `author_site` varchar(200) DEFAULT '',
  `copyright` varchar(255) DEFAULT '',
  `license` varchar(255) DEFAULT '',
  `description` text,
  PRIMARY KEY (`id`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `@wa_plugin` VALUES ('article', 'module', 'Article', '2.0', '2012-3-16', 'web@all', 'web@webatall.org', 'http://webatall.org', 'Copyright &copy; webatall.org', 'GNU LGPL', 'Article module');
INSERT INTO `@wa_plugin` VALUES ('member', 'module', 'Member', '2.0', '2012-3-16', 'web@all', 'web@webatall.org', 'http://webatall.org', 'Copyright &copy; webatall.org', 'GNU LGPL', 'Member module');
INSERT INTO `@wa_plugin` VALUES ('en', 'language', 'English', '2.0', '2012-3-16', 'web@all', 'web@webatall.org', 'http://webatall.org', 'Copyright &copy; webatall.org', 'GNU LGPL', 'Default language package.');
INSERT INTO `@wa_plugin` VALUES ('web', 'template', 'web', '2.0', '2012-3-16', 'web@all', 'web@webatall.org', 'http://webatall.org', 'Copyright &copy; webatall.org', 'GNU LGPL', 'Default template for front end');
INSERT INTO `@wa_plugin` VALUES ('paypal', 'payment', 'Paypal', '2.0', '2012-3-16', 'web@all', 'web@webatall.org', 'http://webatall.org', 'Copyright &copy; webatall.org', 'GNU LGPL', 'Paypal payment');
INSERT INTO `@wa_plugin` VALUES ('kindeditor', 'editor', 'KindEditor', '4.0.6', '2012-3-18', 'kindsoft', 'luolonghao@gmail.com', 'http://kindsoft.net', 'Copyright &copy; kindsoft.net.', 'http://www.kindsoft.net/license.php', 'KindEditor');

DROP TABLE IF EXISTS `@wa_transaction`;
CREATE TABLE `@wa_transaction` (
  `trans_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `trans_no` varchar(50) NOT NULL,
  `type` tinyint(1) unsigned DEFAULT '0',
  `status` tinyint(1) DEFAULT '0',
  `amount` float NOT NULL,
  `unit` char(3) NOT NULL,
  `text` varchar(255) DEFAULT '',
  `member_id` int(11) unsigned DEFAULT '0',
  `username` varchar(50) DEFAULT '',
  `timeadd` int(10) unsigned DEFAULT '0',
  `options` text,
  PRIMARY KEY (`trans_id`),
  KEY `member_id` (`member_id`),
  KEY `trans_no` (`trans_no`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `@wa_unique`;
CREATE TABLE `@wa_unique` (
  `unique_id` int(15) unsigned NOT NULL,
  `unique_key` varchar(50) NOT NULL,
  PRIMARY KEY (`unique_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;