<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
abstract class basemod{
	protected $wa,$db;
	protected $args = array();
	protected $lastid = 0;

	protected function __construct(){
		$this->wa = $GLOBALS['wa'];
		$this->db = $GLOBALS['db'];
	}

	protected function vars($vars){
		foreach($vars as $key=>$var){
			if(is_array($var)){
				if(is_numeric($key)) $key = $var[0];
				$var[2] = is_bool($var[2]) ? $var[2] : true;
				$v[$key] = $this->wa->v($var[0], $var[1], $var[2]);
			}else{
				if(is_numeric($key)) $key = $var;
				$v[$key] = $this->wa->v($var);
			}
		}
		return $v;
	}

	public function a($id, $field = '*'){
		$sql['_type'] = 'select';
		$sql['field'] = $field;
		$sql['table'] = key($this->tabs);
		$sql['where'] = "{$this->prikey} = '$id'";
		$res = $this->db->query($sql);
		$rs = $this->db->row($res);
		if(!$rs) $rs = array();
		return $rs;
	}
	
	protected function _get($sql = array(), $process = ''){
		$sql['_type'] = 'select';
		$tab_name = key($this->tabs);
		$tab_alias = current($this->tabs);
		$this->inc_field($tab_alias, $sql['field']);
		if(empty($sql['table'])) $sql['table'] = "$tab_name $tab_alias";
		$tab_alias = $tab_alias ? "{$tab_alias}." : '';
		if($this->args['id'] != '') $sql['where'][] = "$tab_alias{$this->prikey} = '{$this->args['id']}'";
		if($this->args['sql']) $sql['where'][] = $this->args['sql'];
		if($this->args['orderby']){
			if($tab_alias) $this->args['orderby'] = preg_replace("/(^|,)\s*(\w+)\s+(ASC|DESC)\b/i", "\\1$tab_alias\\2 \\3", $this->args['orderby']);
			$sql['order'] = $this->args['orderby'];
		}
		$res = $this->db->query($sql);
		$rs = $this->db->row($res);
		if($rs && $process) $rs = $this->$process($rs);
		$this->args = array();
		if(!$rs) $rs = array();
		return $rs;
	}
	
	protected function _gets($sql = array(), $process = ''){
		$sql['_type'] = 'select';
		$tab_name = key($this->tabs);
		$tab_alias = current($this->tabs);
		$this->inc_field($tab_alias, $sql['field']);
		if(empty($sql['table'])) $sql['table'] = "$tab_name $tab_alias";
		$tab_alias = $tab_alias ? "{$tab_alias}." : '';
		if($this->args['sql']) $sql['where'][] = $this->args['sql'];
		if($this->args['search'] == true){
			if($search_sql = $this->inc_search()) $sql['where'][] = $search_sql;
		}
		if($this->args['orderby']){
			if($tab_alias) $this->args['orderby'] = preg_replace("/(^|,)\s*(\w+)\s+(ASC|DESC)\b/i", "\\1$tab_alias\\2 \\3", $this->args['orderby']);
			$sql['order'] = $this->args['orderby'];
		}

		if($this->args['setpage'] > 0){
			$number = $this->args['number'] > 0 ? $this->args['number'] : 10;
			$offset = $number * ($this->args['setpage'] - 1);
			$sql['limit'] = "$offset, $number";
			$this->db->setpage($sql, $this->args['item'], $number, $this->args['setpage']);
		}else{
			if($this->args['number'] > 0) $sql['limit'] = "0, {$this->args['number']}";
		}
		$res = $this->db->query($sql, $this->args['unbuf']);

		$arr = array();
		while($rs = $this->db->row($res)){
			if($process) $rs = $this->$process($rs);
			$key = $this->prikey ? $rs[$this->prikey] : ++$i;
			$arr[$key] = $rs;
		}
		$this->args = array();
		return $arr;
	}

	protected function _add($sql = array(), $msg = ''){
		$sql['_type'] = 'insert';
		if(empty($sql['table'])) $sql['table'] = key($this->tabs);
		$this->db->query($sql);
		$this->lastid = $this->db->lastid();
		$arr['key'] = 'INFO_ADD';
		if($msg){
			$add_msg = $this->lastid ? "({$this->prikey} = {$this->lastid})" : '';
			$arr['msg'] = "($msg)@@@$add_msg";
		}
		return $arr;
	}

	protected function _edit($sql = array(), $msg = ''){
		$sql['_type'] = 'update';
		if(empty($sql['table'])) $sql['table'] = key($this->tabs);
		$this->db->query($sql);
		$arr['key'] = 'INFO_EDIT';
		if($msg){
			$add_msg = is_array($sql['where']) ? implode(' AND ', $sql['where']) : $sql['where'];
			$arr['msg'] = "($msg)@@@($add_msg)";
		}
		return $arr;
	}

	protected function _del($sql = array(), $msg = ''){
		$sql['_type'] = 'delete';
		if(empty($sql['table'])) $sql['table'] = key($this->tabs);
		$this->db->query($sql);
		$arr['key'] = 'INFO_DEL';
		if($msg){
			$add_msg = is_array($sql['where']) ? implode(' AND ', $sql['where']) : $sql['where'];
			$arr['msg'] = "($msg)@@@($add_msg)";
		}
		return $arr;
	}
	
	protected function unique($key){
		$sql['_type'] = 'select';
		$sql['table'] = '@db_unique';
		$sql['where'] = "unique_key = '$key'";
		$res = $this->db->query($sql);
		if($rs = $this->db->row($res)){
			$id = $rs['unique_id'] + 1;
			$sql['_type'] = 'update';
			$sql['field']['unique_id'] = "unique_id + 1";
			$this->db->query($sql);
		}else{
			$id = 1;
			$sql['_type'] = 'insert';
			$sql['field']['unique_id'] = $id;
			$sql['field']['unique_key'] = $key;
			$this->db->query($sql);
		}
		return $id;
	}
	
	protected function clear_web($id){
		$rs = $this->a($id, 'category_id');
		if($rs){
			$cid = $rs['category_id'];
			clear_dir(DIR ."/dat/cache_web/$cid/$id", true);
		}
	}

	private function inc_search(){
		$_type = $this->wa->v('_type');
		$_text = $this->wa->v('_text');
		if(!$_text) return '';
		foreach($_text as $key=>$value){
			$field = $this->search[$key];
			$value = trim($value);
			if($field && $value != ''){
				if(!isset($_type[$key])) $_type[$key] = 1;
				switch($_type[$key]){
					case 0 : $sql[] = "$field LIKE '%$value%'"; break;
					case 1 : $sql[] = "$field = '$value'"; break;
					case 2 : $sql[] = "$field >= '$value'"; break;
					case 3 : $sql[] = "$field <= '$value'"; break;
					case 4 : $sql[] = "$field NOT LIKE '%$value%'"; break;
					case 5 : $sql[] = "$field <> '$value'"; break;
					case 6 : $value = preg_replace("/(\s*,\s*|\s+)/i", "' AND '", $value);
							$sql[] = "$field BETWEEN '$value'"; break;
				}
			}
		}
		return implode(' AND ', $sql);
	}
	
	private function inc_field($tab_alias, &$field){
		if($this->args['field']){
			if(!preg_match("/\b{$this->prikey}\b/i", $this->args['field'])) $this->args['field'] .= ", {$this->prikey}";
			if($tab_alias){
				$field = preg_replace("/(^|,)\s*(\w+)(?!\.)/", "\\1 $tab_alias.\\2", $this->args['field']);
			}else{
				$field = $this->args['field'];
			}
		}
		if(empty($field)) $field = '*';
	}
}
?>