<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class do_template{
	private $lng, $dir, $tpl, $cache_file, $cache_func;
	private $funfile = array();
	private $modinit = array();
	private $lang = array();
	private $tags = array();
	private $temp = array();
	private $path = array();

	public function __construct($lng, $tpl, $cache){
		$this->dir = dirname(DIR . $tpl);
		$this->lng = $lng;
		$this->tpl = $tpl;
		$this->cache_file = $cache;
		$this->cache_func = DIR ."/dat/cache_sys/tpl_functions.php";
		if(WA_IN_DEV_MODE || !file_exists($list_file)) $this->tpl_functions();
		$this->tag_table();
		$this->compile();
	}

	private function tag_table(){
		$arr['PHP'] = array("/\{php\s*\}([\s\S]+?)\{\/php\s*\}/", "<?php \\1 ?>", "\\1", '', '*');
		$arr['IF'] = array("/\{if\s+([^\{\}]+)\s*\}/", "<?php if(\\1){ ?>",  " if(\\1){ ", 'PHP', 'CALL,ITEM,LANG');
		$arr['ELSE'] = array("/\{else\s*\}/", "<?php }else{ ?>", " }else{ ", 'PHP', '');
		$arr['-IF'] = array("/\{\/if\s*\}/", "<?php } ?>", " } ", 'PHP', '');
		$arr['GETS'] = array("/\{(gets|get)\s+([^\{\}]+)\s*\}/", '', array($this, 'cb_gets'), 'PHP', 'CALL,ITEM,LANG');
		$arr['-GETS'] = array("/\{\/gets\s*\}/", "<?php } ?>", " } ", 'PHP', '');
		$arr['CALL'] = array("/\{call\s+([^\{\}]+)\s*\}/", "<?php echo \\1; ?>", "\\1", '*', 'CALL,ITEM,LANG');
		$arr['ITEM'] = array("/\{(\w+)\.([^\{\}\(\);\"']+)\s*\}/", '', array($this, 'cb_item'), '*', 'CALL,ITEM,LANG');
		$arr['LANG'] = array("/(['\"]?)\{lang\s+(\w+)\.([^\{\}]+)\s*\}(['\"]?)/", '', array($this, 'cb_lang'), '*', '');	
		$this->tags = $arr;
	}
	
	private function compile(){
		$str = file_get_contents(DIR . $this->tpl);
		$ok = false;
		while(!$ok){
			preg_match_all("/\{include\s+([^\{\}\s]+)\s*\}/", $str, $arr);
			foreach($arr[1] as $i=>$inc){
				$inc_str = '';
				$inc_file = $this->dir .'/'. $inc;
				if(is_dir($inc_file)){
					$files = get_files($inc_file);
					sort($files, SORT_NUMERIC);
					foreach($files as $file){
						$inc_str .= file_get_contents("$inc_file/$file");
					}
				}else{
					$inc_str = file_get_contents($inc_file);
				}
				$str = str_replace($arr[0][$i], $inc_str, $str);
			}
			if(empty($arr) || ++$loop >= 3) $ok = true;
		}

		include($this->cache_func);
		preg_match_all("/\b(\w+)\(/", $str, $arr);
		$names = array_unique($arr[1]);
		foreach($names as $name){
			if(!function_exists($name) && $__WA_FUN[$name] && !in_array($__WA_FUN[$name], $this->funfile)) $this->funfile[] = $__WA_FUN[$name];
		}
		
		$str = $this->tag_parse($str);
		$str = $this->tag_restore($str);		
		$headstr = "";
		foreach($this->funfile as $fun){ $headstr .= 'require(INC .\'/'. $fun .'\');' . PHP_EOL; }
		foreach($this->modinit as $mod){
			if(!class_exists("mod_$mod")) $this->error('ERROR_011', "mod_$mod");
			$headstr .= "\$__". strtoupper($mod) ." = new mod_$mod();" . PHP_EOL; 
		}		
		if($headstr) $str = "<?php $headstr ?>\n$str";
		put_file($this->cache_file, $str);
	}

	private function tag_parse($str){
		$arr = true;
		while($arr){
			$arr = array();
			foreach($this->tags as $k=>$v){
				preg_match_all($v[0], $str, $a);
				foreach($a[0] as $w=>$s){
					if($k == 'PHP' && $this->check_php($a[1][$w])) continue;
					$x = md5($s . ++$j . time());
					$arr[] = $x;
					$this->temp[$x] = array('str' => $s, 'tag' => $k, 'res' => 1);
					$str = preg_replace("/". preg_quote($s, '/') ."/", "<$x>", $str, 1);
				}
			}
			if($arr) $this->path[] = $arr;
		}
		return $str;
	}

	private function tag_restore($str){
		$m = count($this->path) - 1;
		for($i=$m; $i>=0; $i--){
			foreach($this->path[$i] as $k){
				$b = $this->temp[$k];
				$r = $this->tags[$b['tag']];
				if(!preg_match("/(\*|". $b['top'] .")/", $r[3])) $this->error('ERROR_021', $b['tag'].'@@@'.$r[3]);
				if($i >= 1){
					preg_match_all("/<([\w]{32})>/", $b['str'], $c);
					foreach($c[1] as $d){
						if(!preg_match("/(\*|". $this->temp[$d]['tag'] .")/", $r[4])) $this->error('ERROR_022', $b['tag'].'@@@'.$r[4]);
						$this->temp[$d]['res'] = 2;
						$this->temp[$d]['top'] = $b['tag'];
					}
				}
				if($r[1] == ''){
					$this->temp['res'] = $b['res'];
					$e = preg_replace_callback($r[0], $r[2], $b['str']);
				}else{
					$e = preg_replace($r[0], $r[$b['res']], $b['str']);
				}
				$str = str_replace("<$k>", $e, $str);
			}
		}
		return $str;
	}
	
	private function check_php($str){
		foreach($this->tags as $v){
			if(preg_match($v[0], $str)) return 1;
		}
		return 0;
	}
	
	private function cb_item($matches){
		$str = '$'. $matches[1];
		$keys = explode('.', $matches[2]);
		$max = count();
		foreach($keys as $key){
			preg_match("/^<([\w]{32})>$/", $key, $arr);
			if($arr[1] && $this->temp[$arr[1]]){
				$str .= "[$key]";
			}else{
				$str .= "['$key']";
			}
		}
		if($this->temp['res'] == 1) $str = "<?php echo $str; ?>";
		return $str;
	}

	private function cb_gets($matches){
		$arr = preg_split("/\s+(\w+?\s*=|@\s*[\w\.]+\s*)/", ' '. $matches[2], -1, PREG_SPLIT_DELIM_CAPTURE);
		$var = array();
		$sql = array();
		for($i = 1; $i < count($arr); $i = $i + 2){
			$key = trim($arr[$i]);
			$val = trim($arr[$i + 1]);

			if(strpos($key, '@') === 0){
				$ok = preg_match("/^(>=|<=|<>|!=|=|>|<|NOT LIKE|LIKE)\s*(.*)$/i", $val, $subarr);
				if(!$ok) continue;
				if(preg_match("/(^\\\$|^<[\w]{32}>$)/", $subarr[2])){
					if(preg_match("/^[\$]\w+$/", $subarr[2])){
						$subarr[2] = "'{$subarr[2]}'";				
					}else{
						$_k = '$__VAR_'. $i;
						$var[$_k] = $subarr[2];
						$subarr[2] = stripos($subarr[1], 'LIKE') === false ? "'$_k'" : "'%$_k%'";
					}
				}else if(!preg_match("/^(-?\d+[\.\d]*|true|false)$/i", $subarr[2])){
					$subarr[2] = "'". str_replace("'", "\'", $subarr[2]) ."'";
				}
				$key = substr($key, 1);
				if(strpos($key, '.') === false) $key = "<TAB_ALIAS>$key";
				$sql[] = $key .' '. $subarr[1] .' '. $subarr[2];
			}else{
				$key = trim(str_replace('=', '', $key));
				if($key == 'sql') continue;
				$args .= "'$key'=>";
				if(preg_match("/(^\\\$|^<[\w]{32}>$)/", $val)){
					$args .= $val .',';
				}else{
					$is_bool_num = preg_match("/^(-?\d+[\.\d]*|true|false)$/i", $val);
					$args .= $is_bool_num ? "$val," : "'". str_replace("'", "\'", $val) ."',";
				}
				$$key = $val;
			}
		}		
		$join = stripos($join, 'OR') === false ? 'AND' : 'OR';
		if($sql = implode(" $join ", $sql)){
			$modstr = file_get_contents(DIR ."/mod/$name.php", false, null, -1, 100);
			$tab_alias = preg_match("/'@db_\w+'\s*=>\s*'A'/", $modstr) ? 'A.' : '';
			$sql = str_replace('<TAB_ALIAS>', $tab_alias, $sql);
			if($join == 'OR') $sql = "($sql)";
			$args = "array($args'sql'=>\"$sql\")";
			foreach($var as $k=>$v){$vars .= $k .'='. $v .';';}
		}else{
			$args = "array(". substr($args, 0, -1) .")";
		}
		if(!in_array($name, $this->modinit)) $this->modinit[] = $name;
		$item = $item ? '$'. $item : '$rs';
		$mod = strtoupper("\$__$name");
		
		switch($matches[1]){
			case 'get' : 
				$str = $item .' = '. $mod .'->get('. $args .');';
				break;

			case 'gets' :
				if($nolist){
					$str = $item .' = '. $mod .'->gets('. $args .');';
				}else{
					$items = strtoupper(str_replace('$', '$__', $item));
					$str = $items .' = '. $mod .'->gets('. $args .'); foreach('. $items .' as $i=>'. $item .'){';
				}
				break;
		}
		$str = $vars . $str;
		if($this->temp['res'] == 1) $str = "<?php $str ?>";
		return $str;
	}

	private function cb_lang($matches){
		if(!$this->lang[$matches[2]]){
			$lng = "/lng/{$this->lng}/{$matches[2]}.ini";
			$arr = array($lng, '/lng/'. SYS_LANGUAGE ."/{$matches[2]}.ini");
			foreach($arr as $lng){
				if(file_exists(DIR . $lng)){$file = DIR . $lng; break;}
			}
			if($file){
				$str = file_get_contents($file);
				preg_match_all("/\b(.+?)\s*:\s*(.*)\s*;\s*([\r\n]+|$)/", $str, $a);
				foreach($a[1] as $i=>$k){
					$php = '$this->lang[\''. $matches[2] .'\']';
					$b = explode('.', $k);
					foreach($b as $c){ $php .= "['$c']"; }
					eval($php .'=\''. addslashes($a[2][$i]) .'\';');
				}
			}
		}
		$php = '$text = $this->lang[\''. $matches[2] .'\']';
		$arr = explode('.', $matches[3]);
		foreach($arr as $a){ $php .= "['$a']"; }
		eval($php .';');
		if(isset($text)){
			switch(true){
				case is_array($text) :
					if($this->temp['res'] == 1){
						$str = implode(',', $text);
					}else{
						$str = 'array(';
						foreach($text as $k=>$v){
							$str .= "'". addslashes($k) ."'=>'". addslashes($v) ."',";
						}
						$str = substr($str, 0, -1) .')';
					}
					break;
				
				case is_bool($text) :
					if($this->temp['res'] == 1){
						$str = $text ? 'true' : 'false';
					}else{
						$str = $text;
					}
					$str = $matches[1] . $text . $matches[4];
					break;
				
				default:
					if($matches[1] && $matches[1] == $matches[4]) $text = htmlspecialchars(addslashes($text));
					if($this->temp['res'] == 2) $text = "'$text'";
					$str = $matches[1] . $text . $matches[4];
			}
			$str = str_replace('{', '&#123;', $str);
			$str = str_replace('}', '&#125;', $str);
		}else{
			$str = $this->temp['res'] == 1 ? $matches[0] : '';
		}
		return $str;
	}
	
	private function tpl_functions(){
		$list_time = filemtime($this->cache_func);
		$arr = get_files(INC);
		$arr = preg_grep("/^fun_(\w+)\.php$/", $arr);
		foreach($arr as $fun){
			$func_time = max(filectime(INC ."/$fun"), filemtime(INC ."/$fun"));
			if($func_time > $list_time && $func_time < time()){
				foreach($arr as $fun){
					$str = file_get_contents(INC ."/$fun");
					preg_match_all("/\bfunction\s+(\w+)\s*\([^\(\)]*\)\s*\{/", $str, $names);
					foreach($names[1] as $name){
						$list_str .= '$__WA_FUN[\''. $name .'\'] = \''. $fun .'\';'. PHP_EOL;
					}
				}
				file_put_contents($this->cache_func, "<?php". PHP_EOL . $list_str ."?>");
				break;
			}
		}
	}
	
	private function error($key, $msg){
		$GLOBALS['wa']->setmsg($key, $msg);
	}
}
?>