<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
set_time_limit(0);
class do_upload{
	public $files = array();
	public $limit = array();
	public $destpath = '';
	public $destname = '';
	public $nametype = '';
	public $overwrite = false;
	public $prefix = '';

	public function __construct(){
		$this->limit['type'] = 'jpg,gif,bmp,png';
		$this->limit['size'] = 2048;
		$this->destpath = DIR .'/file/temp/'. date('Ym');
	}

	public function set_limit($type, $size = -1){
	/*
		@$type: seperated by comma;
		@$size: in KB; -1 is unlimited.
	*/
		if($type) $this->limit['type'] = preg_replace("/\s+/", '', strtolower($type));
		if($size) $this->limit['size'] = $size;
	}
	
	public function set_path($destpath){
		if(substr($destpath, -1) == '/') $destpath = substr($destpath, 0, -1);
		$this->destpath = $destpath;
	}
	
	public function upload($filefield){
		if(!$_FILES) return false;
		$file = $_FILES[$filefield];

		if(is_array($file['tmp_name'])){
			foreach($file['tmp_name'] as $k => $v){
				if($file['tmp_name'][$k] != ''){
					$this->files[] = array('tmp_name' => $file['tmp_name'][$k], 'name' => $file['name'][$k], 'type' => $file['type'][$k], 'size' => $file['size'][$k], 'error' => $file['error'][$k], 'status' => 0);
				}
			}
		}else{
			if($file['tmp_name'] != ''){
				$this->files[] = array('tmp_name' => $file['tmp_name'], 'name' => $file['name'], 'type' => $file['type'], 'size' => $file['size'], 'error' => $file['error'], 'status' => 0);
			}
		}
		
		$total = count($this->files);
		if($total < 1) return false;

		for($i=0; $i<$total; $i++){
			$res = $this->do_upload($i);
		}
		return $res;
	}

	private function do_upload($index = 0){
		$upfile = $this->files[$index];

		if($upfile['error']){
			switch($upfile['error']){
				case 1  : $msgkey = 'ERROR_043'; break;
				case 2  : $msgkey = 'ERROR_044'; break;
				case 3  : $msgkey = 'ERROR_045'; break;
				case 6  : $msgkey = 'ERROR_048'; break;
				case 7  : $msgkey = 'ERROR_049'; break;
				default : $msgkey = 'ERROR_047';
			}
			$this->error($msgkey, $upfile['name']); return false;
		}
	
		$file_type = strtolower($upfile['type']);
		$file_name = strtolower($upfile['name']);
		$file_snames = explode('.', $file_name);
		$file_sname = trim(end($file_snames));
		
		if(!preg_match("/(^\*$|\b". $file_sname ."\b)/i", $this->limit['type'])){
			$this->error('ERROR_042', ".$file_sname"); return false;
		}

		$file_size = $upfile['size'] / 1024;
		if($this->limit['size'] > 0 && $file_size > $this->limit['size']){
			$this->error('ERROR_041', $upfile['name']. '@@@' . round($file_size, 2) . '@@@' . $this->limit['size']); return false;
		}
	
		if($this->destname){
			$filename = $this->destname;
		}else{
			switch($this->nametype){
				case 'date': $filename = $this->prefix . date('YmdHis') .'.'. $file_sname; break;
				case 'rand': $filename = $this->prefix . randstr(16, 'number_lower_upper') .'.'. $file_sname; break;
				default    : 
					if(!preg_match("/^[\x01-\x7e]+$/")) $file_name = urlencode($file_name);
					$filename = $this->prefix . $file_name;
			}
		}

		$destfile = $this->destpath . '/'. $filename;
		if(!$this->overwrite && file_exists($destfile)){
			$this->error('ERROR_046', $file_name); return false;
		}else{
			if(!file_exists($this->destpath)) make_dir($this->destpath);
			if(!move_uploaded_file($upfile['tmp_name'], $destfile)){
				$this->error('ERROR_047', $file_name); return false;
			}else{
				$this->files[$index]['status'] = 1;
				$this->files[$index]['file'] = $destfile;
				return true;
			}
		}
	}

	private function error($msgkey, $paras){
		$GLOBALS['wa']->setmsg($msgkey, $paras);
	}
}
?>