<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class webatall{
	public $me = array();
	public $env = array('lng'=>SYS_LANGUAGE, 'pos'=>'web');	
	public $tmp = array();
	public $msg = array();
	public $showMSG = true;
	public $echoMSG = 'html';
	
	public function __construct(){
		if(defined('WA_POSITION')) $this->env['pos'] = WA_POSITION;
		$this->echoMSG = trim($this->v('_echoMSG'));
		$this->env['mod'] = trim($this->v('mod', 'system_str'));
		$this->env['act'] = trim($this->v('act', 'system_str'));
		$_id = trim($this->v('id'));
		if($_id != '') $this->env['id'] = $_id;
		$this->env['page'] = $this->v('page', 'system_int');		
		if($this->env['page'] < 1) $this->env['page'] = 1;
		$timezone = $this->get_cookie('my_timezone');
		if(!$timezone) $timezone = SYS_TIMEZONE;
		ini_set('date.timezone', $timezone);
		if(SYS_MULTI_LANGUAGE){
			if(SYS_LANG_SUBDOMAIN){
				preg_match("/^[\w-]+/", $_SERVER["SERVER_NAME"], $arr);
				$_lng = $arr[0];
			}else{
				$_lng = $this->get_cookie('my_language');
			}
			if($_lng && file_exists(DIR ."/lng/$_lng")) $this->env['lng'] = $_lng;
		}
		if($locale = $this->get_cookie('my_locale')){
			$this->tmp['locale'] = setlocale(LC_ALL, $locale);
		}
		if(!$this->tmp['locale']){
			$this->tmp['locale'] = setlocale(LC_ALL, $locale);
		}
	}

	public function v($key, $func = '', $add = true){
		if($_SERVER['REQUEST_METHOD'] == 'POST'){$val = $_POST[$key];}else{$val = $_GET[$key];}
		if(!$add) $val = $this->_stripslashes($val);
		if($func) $this->_check($func, $key, $val);
		if($add) $val = $this->_addslashes($val);
		if(empty($val) && in_array($func, array('system_int', 'system_num'))) $val = 0;
		return $val;
	}
	
	private function _addslashes($var){
		if(!get_magic_quotes_gpc()){
			if(is_array($var)){
				foreach($var as $k=>$v){$var[$k] = $this->_addslashes($v);}
			}else{
				$var = addslashes($var);
			}
		}
		return $var;
	}

	private function _stripslashes($var){
		if(get_magic_quotes_gpc()){
			if(is_array($var)){
				foreach($var as $k=>$v){$var[$k] = $this->_stripslashes($v);}
			}else{
				$var = stripslashes($var);
			}
		}
		return $var;
	}
	
	private function _check($func_str, $key, $str){
		preg_match("/^([a-z]+)_(.+)$/", $func_str, $func_arr);
		$func = $func_arr[1] . '_check';		
		if(function_exists($func)){
			if(is_array($str)){
				foreach($str as $k => $v){$this->_check($func_str, $key.'['. $k .']', $v);}
			}else{
				$arr = $func($func_arr[2]);
				if(!isset($arr['reg'])) $this->setmsg('ERROR_017', $func_str);
				$result = preg_match($arr['reg'], $str);
				if(!$result) $this->setmsg($arr['key'], $key .'@@@'. $str);
			}
		}else{
			$this->setmsg('ERROR_013', $func);
		}
	}

	public function set_cookie($key, $val = '', $ttf = 0, $encode = false){
		if($val == '') $ttf = -86400;
		$livetime = $ttf == 0 ? 0 : time() + $ttf;
		$secure = $_SERVER['SERVER_PORT'] == 443 ? 1 : 0;
		if($encode){
			$ip = get_ip();
			$val = substr(md5($val.$ip.SYS_ENCODE_SALT), 8, 16) .$val;
			setcookie("__WA:$key", 1, $livetime, '/', '.'. SYS_ROOTNAME, $secure, true);
		}else{
			if(isset($_COOKIE["__WA:$key"])) setcookie("__WA:$key", '', -1, '/', '.'. SYS_ROOTNAME, $secure);
		}
		$_COOKIE[$key] = $val;
		setcookie($key, $val, $livetime, '/', '.'. SYS_ROOTNAME, $secure, true);
	}

	public function get_cookie($key){
		if(!isset($_COOKIE[$key])){
			return '';
		}else{
			if($_COOKIE["__WA:$key"]){
				$md5_old = substr($_COOKIE[$key], 0, 16);
				$val = substr($_COOKIE[$key], 16);
				$ip = get_ip();
				$md5_new = substr(md5($val.$ip.SYS_ENCODE_SALT), 8, 16);
				if($md5_old == $md5_new){return $val;}else{return '';}
			}else{
				return $this->_addslashes($_COOKIE[$key]);
			}
		}
	}

	public function set_session($key, $val = '', $ttf = 0){
		if($val == '') $ttf = -86400;
		if(!isset($_SESSION)) session_start();
		if($ttl >= 0){
			$_SESSION[$key] = $val;
		}else{
			unset($_SESSION[$key]);
			if(empty($_SESSION)) session_destroy();
		}
		$this->set_cookie(session_name(), session_id(), $ttf);
	}
	
	public function get_session($key){
		if(!isset($_SESSION)) session_start();
		return $_SESSION[$key];
	}
	
	public function lng($key){
		$arr = explode('.', $key);
		if(!$this->tmp["lang.{$arr[0]}"]){
			$lng = "/lng/{$this->env['lng']}/{$arr[0]}.ini";
			$lngs = array($lng, '/lng/'. SYS_LANGUAGE ."/{$arr[0]}.ini");
			foreach($lngs as $lng){
				if(file_exists(DIR . $lng)){$file = DIR . $lng; break;}
			}
			if($file){
				$str = file_get_contents($file);
				preg_match_all("/\b(.+?)\s*:\s*(.*)\s*;\s*([\r\n]+|$)/", $str, $a);
				foreach($a[1] as $i=>$k){
					$php = '$this->tmp[\'lang.'. $arr[0] .'\']';
					$b = explode('.', $k);
					foreach($b as $c){ $php .= "['$c']"; }
					eval($php .'=\''. addslashes($a[2][$i]) .'\';');
				}
			}
		}
		$php = '$text = $this->tmp[\'lang.'. $arr[0] .'\']';
		for($i=1; $i<count($arr); $i++){ $php .= "['{$arr[$i]}']"; }
		eval($php .';');
		if($text === null) $text = '{'. $key .'}';
		return $text;
	}

	public function mod($class, $method){
		$class = 'mod_'. $class;
		if(class_exists($class)){
			$mod = new $class();
		}else{
			$this->setmsg('ERROR_011', $class);
		}
		if(method_exists($mod, $method)){
			$args = func_get_args();
			$arr = array();
			for($i=2; $i<count($args); $i++){$arr[] = $args[$i];}
			$res = call_user_func_array(array($mod, $method), $arr);
		}else{
			$this->setmsg('ERROR_012', "$method@@@$class");
		}
		return $res;
	}

	public function tpl($tpl){
		$file = DIR . $tpl;
		if(file_exists($file)){		
			$cache_file = DIR .'/dat/cache_tpl/'. $this->env['lng'] . str_replace('/', '_', $tpl);
			if(WA_IN_DEV_MODE || !file_exists($cache_file)){
				$t = new do_template($this->env['lng'], $tpl, $cache_file);
			}
			return $cache_file;
		}else{
			$this->setmsg('ERROR_016', $file);
		}
	}
	
	public function setmsg($key, $str = ''){
		$arr['key'] = $key;
		$arr['paras'] = explode('@@@', $str);
		if(WA_IN_DEV_MODE && preg_match("/^(". WA_DEBUG_LEVEL .")_/", $key)){
			$arr['debug'] = debug_backtrace();
		}
		$this->msg[] = $arr;
		if($this->showMSG) $this->putmsg();
	}
	
	public function putmsg($MSG = array()){
		$this->showMSG = false;
		if($MSG['key'] && !isset($this->msg[$MSG['key']])){
			$this->setmsg($MSG['key'], $MSG['msg']);
		}
		if(empty($this->msg)) return '';		
		ob_clean();
		require(INC .'/inc_message.php');
		exit();
	}

	public function money($amount, $prefix = false, $symbol = true){
		$curr = get_prefer(array($this->get_cookie('my_currency'), SYS_CURRENCY));
		if(!$rs = $this->tmp["curr.$curr"]){
			$mod = new mod_currency();
			$rs = $mod->get(array('id'=>$curr));
			$this->tmp["curr.$curr"] = $rs;
		}
		if(!$rs) return $amount;
		$amount = round($amount * $rs['rate'], $rs['decimals']);
		if($symbol) $amount = $rs['symbol'] . $amount;	
		if($prefix) $amount = $rs['currency'] . $amount;
		return $amount;
	}

	public function check($permission_code, $category_id = 0){
		$pcode = str_replace('*', '\*', $permission_code);
		$re = preg_replace("/([^\.]+)\.([^\.]*)/", "(^|,)(\*|$1)\.(\*|$2)(,|$)", $pcode);
		if(preg_match("/$re/", $this->me['permission'])){
			if($this->me['cat_limit'] && $category_id){
				if(!preg_match("/(^|,)$category_id(,|$)/", $this->me['cat_limit'])) $this->setmsg('INFO_CATEGORY_LIMIT', $category_id);
			}
		}else{
			$this->setmsg('INFO_NO_PERMISSION', "$permission_code");
		}
	}
	
	public function mail($tpl, $to, $from = '', $showMSG = false){
		if(!MAIL_SENDTYPE) return;
		ob_flush();
		$lng = $this->env['lng'];
		$gid = $this->me['member_gid'];
		$wa = $this;
		$arr = array("$tpl.$lng.$gid", "$tpl.$gid", "$tpl.$lng", "$tpl");
		foreach($arr as $tpl){
			if(file_exists(DIR ."/tpl/mail/$tpl.htm")){
				include($this->tpl("/tpl/mail/$tpl.htm"));
				$body = ob_get_clean();
				preg_match("/<title>(.+?)<\/title>/i", $body, $arr);
				$sm = new do_sendmail();
				$sm->subject = $arr[1];
				$sm->body = $body;
				if($from){
					$sm->add($from, 'from');
				}else{
					$sm->add(MAIL_FROMMAIL .'|'. MAIL_FROMNAME, 'from');
				}
				$sm->add($to, 'to');
				$sm->send();
				if($showMSG) $this->setmsg('INFO_MAIL_IS_SENT');
				break;
			}
		}
	}

	public function zip($str){
		if(SYS_COMPRESSION <= 0) return $str;
		if(strstr($_SERVER["HTTP_ACCEPT_ENCODING"], 'gzip') && function_exists('gzencode')){
			$type = 'gzip';
			$zip = gzencode($str, SYS_COMPRESSION);
		}else if(strstr($_SERVER["HTTP_ACCEPT_ENCODING"], 'deflate') && function_exists('gzdeflate')){
			$type = 'deflate';
			$zip = gzdeflate($str, SYS_COMPRESSION);
		}
		if($type) $str = '<?php header("Content-Encoding:'. $type .'"); header("Vary: Accept-Encoding");?>'. "\n" . $zip;
		return $str;
	}
}
?>