<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class db_stuff{
	public $page = array();
	private $db = array();
	private $link = 0;

	public function __construct(){
		$this->db['data'] = DB_DATA;
		$this->db['debug'] = DB_DEBUG;
		$this->db['prefix'] = DB_PREFIX;
	}
	
	public function __destuct(){
		if($this->link){
			sqlite_close($this->link);
			$this->link = 0;
		}
	}

	private function conn(){
		$this->link = sqlite_open(DIR .'/dat/'. $this->db['data'], 0666);
		if(!$this->link) $this->error('ERROR_025', $this->db['data']);
	}
	
	private function error($msgkey, $paras){
		$GLOBALS['wa']->setmsg($msgkey, $paras);
	}

	public function query($sql, $ub = false){
		if(is_array($sql)){
			$_type = $sql['_type'] ? "sql_{$sql['_type']}" : "sql_select";
			$sql = $this->$_type($sql);
		}
		if(!$this->link) $this->conn();
		$sql = $this->prefix($sql);
		$res = $ub ? sqlite_unbuffered_query($this->link, $sql, SQLITE_ASSOC) : sqlite_query($this->link, $sql, SQLITE_ASSOC);
		if(!$res){
			$err_sql = $this->db['debug'] ? $sql : '(...)';
			$this->error('ERROR_026', $err_sql . '@@@' . sqlite_error_string(sqlite_last_error($this->link)));
		}
		return $res;
	}

	public function row($res){
		$arr = sqlite_fetch_array($res, SQLITE_ASSOC);
		foreach($arr as $k=>$v){
			$_k = preg_replace("/^\w+\./", '', $k);
			if($k != $_k){
				$arr[$_k] = $v;
				unset($arr[$k]);
			}
		}
		return $arr;
	}

	public function setpage($sql, $item = 'rs', $pagesize = 10, $curpage = 1){
		if(is_array($sql)){
			$sql['field'] = 'COUNT(*)';
			unset($sql['group']);
			unset($sql['order']);
			unset($sql['limit']);
		}		
		$res = $this->query($sql);
		$rs = sqlite_fetch_array($res);
		$arr = array(
			'number' => $rs[0],
			'pagesize' => $pagesize,
			'curpage' => $curpage
		);
		$this->page[$item] = $arr;
	}

	public function lastid(){
		return sqlite_last_insert_rowid($this->link);
	}

	private function prefix($sql){
		$sql = str_replace('@db_', $this->db['prefix'], $sql);
		$sql = str_replace("\'", "''", $sql);
		$sql = stripslashes($sql);
		$sql = str_replace('--', '\--', $sql);
		return $sql;
	}

	private function sql_select($arr){
		extract($arr);
		if(!$field) $field = '*';
		$sql = "SELECT $field FROM $table";	
		if(is_array($where)) $where = $this->get_where($where);
		if($where) $sql .= " WHERE $where";
		if($group) $sql .= " GROUP BY $group";	
		if($order) $sql .= " ORDER BY $order";
		if($limit) $sql .= " LIMIT $limit";
		return $sql;
	}

	private function sql_insert($arr){
		extract($arr);
		$sql  = "INSERT INTO \"$table\"";
		foreach($field as $k=>$v){
			$fields .= ",\"$k\"";
			$values .= ",'$v'";
		}
		$fields = substr($fields, 1);
		$values = substr($values, 1);
		$sql .= " ($fields) VALUES ($values)";
		return $sql;
	}
	
	private function sql_update($arr){
		extract($arr);
		$sql = "UPDATE \"$table\" SET ";
		foreach($field as $k=>$v){
			preg_match("/(\s*$k\s*[+-]\s*)?([\s\S]*)/", $v, $a);
			$fields .= ",\"$k\" = {$a[1]}'{$a[2]}'";
		}
		$sql .= substr($fields, 1);
		if(is_array($where)) $where = $this->get_where($where);
		if($where) $sql .= " WHERE $where";
		return $sql;
	}

	private function sql_delete($arr){
		extract($arr);
		$sql = "DELETE FROM $table";
		if(is_array($where)) $where = $this->get_where($where);
		if($where) $sql .= " WHERE $where";
		return $sql;
	}

	private function get_where($arr){
		$str = preg_replace("/^\(([^\(\)]*)\)$/", "\\1", implode(' AND ', $arr));
		return $str;
	}
}
?>