<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
function make_dir($path, $mode = 0777){
	$path = preg_replace("/^". preg_quote(DIR .'/', '/') ."/", '', $path, 1);
	$arr = explode('/', $path);
	$curpath = DIR;
	$len = count($arr);
	for($i=0; $i<$len; $i++){
		$curpath .= '/' . $arr[$i];
		if(!file_exists($curpath)) $res = mkdir($curpath, $mode);
	}
	return $res;
}

function copy_dir($source, $dest){
	if(!file_exists($source)) return false;
	if(!file_exists($dest) && !make_dir($dest)) return false;
	$fp = opendir($source);
	if($fp){
		while(false !== ($file = readdir($fp))){
		   if($file != "." && $file != ".."){
				$thispath = "$source/$file";
				$destpath = "$dest/$file";
				if(is_dir($thispath)){
					copy_dir($thispath, $destpath);
				}else{
					copy($thispath, $destpath);
				}
			}
		}
	}
	closedir($fp);
	return true;
}
	
function clear_dir($path, $deldir = false){
	if(!file_exists($path)) return false;	
	$fp = opendir($path);
	if($fp){
		while(false !== ($file = readdir($fp))){
		   if($file != "." && $file != ".."){
				$thispath = "$path/$file";
				if(is_dir($thispath)){
					clear_dir($thispath, true);
				}else{
					unlink($thispath);
				}
			}
		}
	}
	closedir($fp);
	if($deldir) rmdir($path);
	return true;
}

function count_dir($path){
	$arr = array();
	$fp = opendir($path);
	while(false !== ($file = readdir($fp))){
		if($file != '.' && $file != '..'){
			$fullfile = "$path/$file";
			if(is_dir($fullfile)){
				$subarr = count_dir($fullfile);
				$arr['size'] += $subarr['size'];
				$arr['files'] += $subarr['files'];
				$arr['folders'] += $subarr['folders'] + 1;
			}else{
				$arr['size'] += filesize($fullfile);
				$arr['files'] += 1;
			}
		}
	}
	closedir($fp);
	return $arr;
}

function put_file($file, $str, $append = false){
	$create_path = dirname($file);
	if(!file_exists($create_path)) make_dir($create_path);
	$flag = $append ? FILE_APPEND : null;
	return file_put_contents($file, $str, $flag);
}

function get_files($path){
	$arr = array();
	if(!file_exists($path)) return $arr;

	if(substr($path, -1, 1) != '/') $path .= '/';
	if($handle = opendir($path)){
		while(false !== ($file = readdir($handle))){
		   if(is_file($path . $file)) $arr[] = $file;
		}
		closedir($handle);
	}
	return $arr;
}

function get_folders($path){
	$arr = array();
	if(!file_exists($path)) return $arr;

	if(substr($path, -1, 1) != '/') $path .= '/';
	if($handle = opendir($path)){
		while(false !== ($folder = readdir($handle))){
		   if(is_dir($path . $folder) && $folder != '.' && $folder != '..') $arr[] = $folder;
		}
		closedir($handle);
	}
	return $arr;
}
?>