<?php
if(!defined('DIR')) exit('<h1>HTTP/1.1 404 Not Found</h1>');
$msgstrs = '';
foreach($this->msg as $k=>$arr){
	$key = $arr['key'];
	$key_arr = explode('_', $key);
	$filename = strtolower($key_arr[0]);
	$msgstr = $this->lng($filename .'.'. $key);
	if(is_array($arr['paras'])){
		foreach($arr['paras'] as $i=>$para){
			$j = $i % 3;
			$para = preg_replace("/^(". preg_quote(DIR, '/') .")/", '', $para, 1);
			$para = block_tags($para);
			$para = str_replace('$', '&#36;', $para);
			$msgstr = preg_replace('/%s/', '<span class="MSG_'. $j .'"> '. $para .' </span>', $msgstr, 1, $count);
			if(!$count) $msgstr .= $para;
		}
	}	
	$msgstr = str_replace('%s', '', $msgstr);
	
	if(in_array($this->echoMSG, array('js_alert', 'js_silent', 'text', 'alert', 'return'))){
		$msgstrs .= preg_replace("/[\r\n]/", "\\n", addslashes(strip_tags($msgstr))) ."\\n";
	}else{
		$keystr = preg_match("/^(". WA_DEBUG_LEVEL .")_/", $key) ? '<span class="MSG_KEY">['. $key .']</span> ' : '';
		if(is_array($arr['debug'])){
			foreach($arr['debug'] as $i=>$subarr){
				$addstr = $subarr['function'] ? "{$subarr['function']}(): " : "";
				$subarr['file'] = str_replace(DIR, '', $subarr['file']);
				$debugstr .= "<li>{$addstr}Line {$subarr['line']} @ {$subarr['file']}</li>";
			}
		}
		if($debugstr){
			$debugstr = ' [<a class="MSG_DETAIL" href="javascript://" onclick="msg_detail(\''. $key .'\');">'. $this->lng('all.detail') .'</a>] <ol id="'. $key .'" class="MSG_DEBUG" style="display:none">'. $debugstr .'</ol>';
		}
		$msgstrs .= '<li>'. $keystr . $msgstr . $debugstr .'</li>';
	}
}

switch($this->echoMSG){
	case 'js_alert' :
	case 'js_silent' :
		echo "_echoMSG = '". $this->echoMSG ."';";
		echo "_text = '". $msgstrs ."';";
		echo "_code = '". $MSG['code'] ."';//";
		break;

	case 'text' :
		echo $msgstrs;
		break;

	case 'alert' :
		echo '<script type="text/javascript">alert("'. $msgstrs .'");</script>';
		break;

	case 'return' :
		return $msgstrs;
		break;

	default :
?>
	<!DOCTYPE html>
	<html dir="<?php echo $this->lng('all._dir'); ?>">
	<head>
	<title><?php echo $this->lng('all.msg'); ?> - <?php echo SYS_SITENAME; ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=<?php echo SYS_CHARSET; ?>">
	<?php if($MSG['next']) echo '<meta http-equiv="refresh" content="3; URL='. $MSG['next'] .'">'; ?>
	<link href="/img/msg.css" type="text/css" rel="stylesheet">
	<script type="text/javascript">
	window.onload = function(){
		if(this.location != top.location) parent._auto();
	}
	function msg_detail(key){
		var obj = document.getElementById(key);
		if(obj.style.display == 'none'){obj.style.display = '';}else{obj.style.display = 'none';}
	}
	</script>
	</head>
	<body>
	<br><br><br>
	<div class="b">
		<div class="t"><?php echo SYS_SITENAME; ?> <?php echo $this->lng('all.msg'); ?></div>
		<div class="c">
			<div class="e"><?php echo $msgstrs; if($MSG['next']){ echo '<li><a href="'. $MSG['next'] .'">'. $this->lng('all.redirect') .'</a></li>'; } ?></div>
			<div><span class="l"><a href="#" onclick="window.history.go(-1);return false;" class="a"><?php echo $this->lng('all.button_back'); ?></a></span><span class="r"><?php if($MSG['url']){ echo '<a href="'. $MSG['url'] .'" class="a">'. $this->lng('all.button_goto') .'</a>'; }else{ echo get_date(time(), SYS_SHORT_DATE);} ?></span><br class="clear"></div>
		</div>
	</div>
	<script type="text/javascript"><?php echo $MSG['code']; ?></script>
	</body>
	</html>
<?php
}
?>