<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class mod_member extends basemod{
	protected $tabs = array(
		'@db_member'      => 'A',
		'@db_member_group' => 'B'
	);
	protected $search = array(
		'member_id' => 'A.member_id',
		'member_gid' => 'A.member_gid',
		'status' => 'A.status',
		'memship' => 'A.memship',
		'balance' => 'A.balance',
		'username' => 'A.username',
		'timeadd' => 'A.timeadd',
		'email' => 'A.email'
	);
	protected $prikey = 'member_id';

	public function __construct(){
		parent::__construct();
	}

	public function get($args){
		$this->args = $args;
		$sql['field'] = "A.*, B.gname, B.{$this->wa->env['pos']}_perm AS permission, B.{$this->wa->env['pos']}_limit AS cat_limit";
		$sql['table'] = '@db_member A, @db_member_group B';
		$sql['where'][] = 'B.member_gid = A.member_gid';
		$rs = parent::_get($sql);

		if($args['flag'] == 'all'){
			$sql = array();
			$sql['field'] = '*';
			$sql['table'] = '@db_member_'. $rs['memship'];
			$sql['where'] = "member_id = '{$args['id']}'";
			$arr = parent::_get($sql);
			$rs = array_merge($rs, $arr);
		}

		return $rs;
	}

	public function gets($args){
		$this->args = $args;
		$sql['field'] = "A.member_id, A.member_gid, A.username, A.status, A.email, A.balance, A.frozen, A.points, A.usedsize, A.memship, B.gname";
		$sql['table'] = '@db_member A, @db_member_group B';
		$sql['where'][] = 'B.member_gid = A.member_gid';
		return parent::_gets($sql);
	}

	public function forgot(){
		$username = $this->wa->v('username', 'system_req');
		$sql['field'] = 'email';
		$sql['table'] = '@db_member';
		$sql['where'][] = "username = '$username'";
		$sql['where'][] = "status > 0";
		if($rs = parent::_get($sql)){
			$email = $rs['email'];
			$this->wa->mail('member.forgot', $email, '', true);
		}else{
			$this->wa->setmsg('INFO_USERNAME_WRONG', $username);
		}
	}

	public function reset(){
		$username = $this->wa->v('username', 'system_req');
		$password = $this->wa->v('password', 'system_req');
		$key = $this->wa->v('key', 'system_req');
		$time = $this->wa->v('time', 'system_req');
		if($time + 86400 * 7 > time()){
			if(md5($time . SYS_ENCODE_SALT) == $key){
				$sql['field']['password'] = md5($password);
				$sql['where'] = "username = '{$username}'";
				parent::_edit($sql);
				$this->wa->setmsg('INFO_DONE', '('. $this->wa->lng('web.reset_password') .' : '. $password .')');
			}else{
				$this->wa->setmsg('INFO_MAIL_LINK_INVALID');
			}
		}else{
			$this->wa->setmsg('INFO_MAIL_LINK_EXPIRED');
		}
	}

	public function signup(){
		if(MEM_SIGNUP_CODE){
			$vc = new do_captcha();
			$vc->verify();
		}

		$username = $this->wa->v('username', 'system_req');
		$password = $this->wa->v('password', 'system_req');
		$email = $this->wa->v('email');
		$memship = $this->wa->v('memship');

		$rs = $this->get(array('sql' => "A.username = '$username'", 'field' => 'member_id'));
		if($rs) $this->wa->setmsg('INFO_USERNAME_EXISTS', $username);
		if(!$memship) $memship = 'default';

		$sql['field']['username'] = $username;
		$sql['field']['password'] = md5($password);
		$sql['field']['email'] = $email;
		$sql['field']['memship'] = $memship;
		$sql['field']['member_gid'] = MEM_START_GROUP;
		$sql['field']['status'] = MEM_START_STATUS;
		$sql['field']['timeadd'] = time();
		$sql['field']['ipadd'] = get_ip();
		$sql['field']['timelast'] = time();
		$sql['field']['iplast'] = get_ip();
		$res = parent::_add($sql);
		$member_id = $this->lastid;

		if(MEM_AUTHTYPE == 'session'){
			$this->wa->set_session('auth', $member_id);		
		}else{
			$this->wa->set_cookie('auth', md5($password).$member_id);
		}
		
		$this->wa->mail('member.signup', "$email|$username");

		$goto = $this->wa->v('goto');
		if(!$goto) $goto = '/mem';
		header("Location: $goto");
		exit;
	}

	public function signin(){
		$username = $this->wa->v('username', 'system_req');
		$password = $this->wa->v('password', 'system_req');
		$livetime = $this->wa->v('livetime', 'system_int');
		$security = $this->wa->v('security', 'system_int');

		$sql['field'] = 'member_id,username,password,member_gid,timelast,iplast';
		$sql['table'] = '@db_member';
		$sql['where'][] = "username = '$username'";
		$sql['where'][] = "status > 0";
		if($rs = parent::_get($sql)){
			if($rs['password'] == md5($password)){
				$sql = array();
				$sql['field']['timeprev'] = $rs['timelast'];
				$sql['field']['ipprev'] = $rs['iplast'];
				$sql['field']['timelast'] = time();
				$sql['field']['iplast'] = get_ip();
				$sql['where'][] = "member_id = '{$rs['member_id']}'";
				parent::_edit($sql);
				
				$sql = array();
				$sql['table'] = '@db_member_setting';
				$sql['where'] = "member_id = '{$rs['member_id']}'";
				$arr = parent::_get($sql);
				unset($arr['member_id']);
				foreach($arr as $k=>$v){
					if(trim($v)) $this->wa->set_cookie($k, $v, 30 * 86400);
				}

				if(MEM_AUTHTYPE == 'session'){
					$this->wa->set_session('auth', $rs['member_id']);		
				}else{
					$this->wa->set_cookie('auth', md5($password).$rs['member_id'], $livetime * 86400, $security);
				}

				$goto = $this->wa->v('goto');
				if(!$goto) $goto = '/mem';
				header("Location: $goto");
				exit;
			}else{
				$this->wa->setmsg('INFO_PASSWORD_WRONG', $password);
			}
		}else{
			$this->wa->setmsg('INFO_USERNAME_WRONG', $username);
		}
	}

	public function auth(){
		if(MEM_AUTHTYPE == 'session'){
			$auth = $this->wa->get_session('auth');
			$arr['id'] = $auth;
		}else{
			$auth = $this->wa->get_cookie('auth');
			$arr['sql'] = "A.password = '". substr($auth, 0, 32) ."'";
			$arr['id'] = substr($auth, 32);
		}
		if($arr['id'] > 0){
			$arr['field'] = "A.member_id, A.member_gid, A.username, A.status, A.email, A.balance, A.frozen, A.points, A.usedsize, A.memship, B.gname, B.{$this->wa->env['pos']}_perm AS permission, B.{$this->wa->env['pos']}_limit AS cat_limit";
			$me = $this->get($arr);
		}
		if(!$me){
			$me['member_id'] = 0;
			$me['member_gid'] = 0;
			$guest = $this->wa->get_cookie('guest');
			if(preg_match('/^(@|W|A)\d+$/', $guest)){
				$me['username'] = $guest;
			}else{
				$ip = ip2long(get_ip());
				if($ip > 0){
					$ip -= 2130706433;
					if($ip > 0){
						$me['username'] = '@'. $ip;
					}else{
						$me['username'] = 'A'. abs($ip);
					}
				}else{
					$me['username'] = 'W'. abs($ip);
				}
				$this->wa->set_cookie('guest', $me['username'], 86400 * 10);
			}
			$sql['table'] = '@db_member_group';
			$sql['field'] = "gname, {$this->wa->env['pos']}_perm AS permission, {$this->wa->env['pos']}_limit AS cat_limit";
			$sql['where'] = 'member_gid = 0';
			$rs = parent::_get($sql);
			$me = array_merge($me, $rs);

			if($arr['id'] > 0){
				if(MEM_AUTHTYPE == 'session'){
					$this->wa->set_session('auth', '');
				}else{
					$this->wa->set_cookie('auth', '');
				}
			}
		}
		$this->wa->me = $me;
	}

	public function logout(){
		if(MEM_AUTHTYPE == 'session'){
			$this->wa->set_session('auth', '');
		}else{
			$this->wa->set_cookie('auth', '');
		}
		header('location: /');
		exit;
	}

	public function mem_edit(){
		$this->wa->env['id'] = $this->wa->me['member_id'];
		$email = $this->wa->v('email');
		$password_old = $this->wa->v('password_old');
		$password_new = $this->wa->v('password_new');

		if($password_old != ''){
			$rs = parent::a($this->wa->me['member_id'], 'password');
			if($rs['password'] == md5($password_old)){
				$sql['field']['password'] = md5($password_new);
			}else{
				$this->wa->setmsg('INFO_PASSWORD_WRONG', $password_old);
			}
		}else{
			$this->inc_edit();
			$sql['field']['email'] = $email;
		}
		$sql['where'][] = "member_id = {$this->wa->me['member_id']}";
		return parent::_edit($sql);
	}

	public function sys_edit(){
		$id = $this->wa->env['id'];
		$member_gid = $this->wa->v('member_gid');
		$status = $this->wa->v('status');
		$email = $this->wa->v('email');
		$password = $this->wa->v('password');

		$this->inc_edit();

		$sql['field']['member_gid'] = $member_gid;
		$sql['field']['status'] = $status;
		$sql['field']['email'] = $email;
		if(trim($password) != ''){
			$sql['field']['password'] = md5($password);
		}
		$sql['where'][] = "member_id = '$id'";
		return parent::_edit($sql, $id);
	}

	private function inc_edit(){
		$id = $this->wa->env['id'];
		$memship = $this->wa->v('memship');
		$rs = parent::a($id, 'memship');
		if(!$rs) return false;
		$sql['field'] = 'member_id';
		$sql['table'] = '@db_member_'. $rs['memship'];
		$sql['where'] = "member_id = '$id'";
		$rs = parent::_get($sql);
		$sql['field'] = array();
		foreach($memship as $key => $val){
			$sql['field'][$key] = $val;
		}
		if($rs){
			parent::_edit($sql);
		}else{
			$sql['field']['member_id'] = $id;
			parent::_add($sql);
		}
	}

	public function sys_bat(){
		$ids = $this->wa->v('selectme', 'system_int');
		if(!$ids) $this->wa->setmsg('ERROR_050');
		$str = implode(',', $ids);
		$batcmd = $this->wa->v('batcmd');

		$this->wa->showMSG = false;
		switch($batcmd){
			case 'ban' :
				$sql['field']['status'] = -1;
				$sql['where'] = "member_id IN ($str)";
				parent::_edit($sql);
				$text = $this->wa->lng('member.ban');
				break;

		}

		$arr['msg'] = "'$text'";
		return $arr;
	}

	public function usedsize($size){
		$member_id = $this->wa->me['member_id'];
		if($member_id > 0){
			$size = ceil($size);
			$sql['field']['usedsize'] = $size;
			$sql['where'] = "member_id = '$member_id'";
			parent::_edit($sql);
			$this->wa->me['usedsize'] = $size;
		}
	}
}
?>