<?php
/* web@all CMS, Copyright (C) webatall.org, Author:poetbi@gmail.com, License: http://webatall.org/license.php */
class mod_payment extends basemod{
	protected $tabs = array('@db_plugin' => '');
	protected $search = array();
	protected $prikey = 'id';

	public function __construct(){
		parent::__construct();
	}

	public function get($args){
		$this->args = $args;
		return parent::_get($sql, 'inc_rs');
	}

	public function gets($args){
		$this->args = $args;
		$sql['where'][] = "type = 'payment'";
		return parent::_gets($sql);
	}

	public function sys_edit(){
		extract($this->vars());
		$id = $this->wa->env['id'];
		$options['account'] = $account;
		$options['description'] = $description;
		$options['currency'] = strtoupper($currency);
		$options['fee'] = "{$fee_percent}_{$fee_fixed}";

		$config = DIR ."/my/$id/config.php";
		$this->put_config($config, $options);		
		$sql['field']['title'] = $title;
		$sql['where'][] = "id = '$id'";
		return parent::_edit($sql, $title);
	}

	public function sys_del(){
		$id = $this->wa->env['id'];
		$sql['where'] = "id = '$id'";
		if($id) clear_dir(DIR ."/my/$id", true);
		return parent::_del($sql, $id);
	}

	protected function inc_rs($rs){
		include(DIR ."/my/{$rs['id']}/config.php");
		$rs = array_merge($PAY, $rs);
		$rs['options'] = array_diff(array_keys($PAY), array('account', 'fee', 'currency', 'description'));

		if($rs['fee']){
			$fee = explode('_', $rs['fee']);
			$rs['fee_percent'] = $fee[0];
			$rs['fee_fixed'] = $fee[1];
		}
		return $rs;
	}

	private function put_config($config, $options){
		$str = file_get_contents($config);
		foreach($options as $k=>$v){
			if(!preg_match("/^(-?\d+[\.\d]*|true|false)$/i", $v)) $v = "'$v'";
			$str = preg_replace("/\\\$PAY\['". $k ."'\]\s*=[\s\S]*?;/", "\\\$PAY['". $k ."'] = ". $v .";", $str);
		}
		$bak_file = preg_replace("/^". preg_quote(DIR, '/') ."/", DIR .'/bak', $config, 1);
		$create_path = dirname($bak_file);
		if(!file_exists($create_path)) make_dir($create_path);
		copy($config, $bak_file);
		file_put_contents($config, $str);
	}

	protected function vars(){
		$vars = array(
			array('title', 'system_req'),
			array('fee_percent', 'system_num'),
			array('fee_fixed', 'system_num'),
			array('currency', 'system_str'),
			array('account', 'system_req'),
			'description',
			'options'
		);
		return parent::vars($vars);
	}

	//SYS_CURRENCY => currency
	public function pay_amount($amount, $curr, $fee = '0_0'){
		$mod = new mod_currency();
		$arr = $mod->gets(array('field'=>'rate, decimals'));
		$to = $arr[$curr];

		$fee = explode('_', $fee);
		$fee_percent = $fee[0];
		$fee_fixed = $fee[1];
		$amount = $amount * (1 + $fee_percent/100) + $fee_fixed;
		$amount = $amount * $to['rate'];
		
		$base = 1;
		for($i=0; $i<$to['decimals']; $i++){ $base *= 10; }		
		$amount *= $base; 
		$amount = ceil($amount);
		$amount /= $base;
		
		return $amount;
	}

	//currency => SYS_CURRENCY
	public function get_amount($amount, $curr, $fee = '0_0'){
		$mod = new mod_currency();
		$arr = $mod->gets(array('field'=>'rate, decimals'));
		$from = $arr[$curr];
		$to = $arr[SYS_CURRENCY];

		$fee = explode('_', $fee);
		$fee_percent = $fee[0];
		$fee_fixed = $fee[1];
		$amount = $amount / $from['rate'];
		$amount = ($amount - $fee_fixed) / (1 + $fee_percent/100);
		$amount = round($amount, $to['decimals']);

		return $amount;
	}

	public function succeed($trans_no, $msg = ''){
		$mod = new mod_transaction();
		$rs = $mod->get(array('sql'=>"trans_no = '$trans_no'"));
		if($rs && $rs['status'] == 0){
			$amount = $this->get_amount($rs['amount'], $rs['unit'], $rs['fee']);
			$text = $rs['text'] . '('. SYS_CURRENCY .':'. $amount .')';
			$sql['field']['text'] = $text;
			
			$arr = unserialize($rs['options']);
			$arr['from_email'] = $GLOBALS['from_email'];
			$arr['from_id'] = $GLOBALS['from_id'];
			$options = serialize($arr);

			$sql['table'] = '@db_transaction';
			$sql['field']['status'] = 1;
			$sql['field']['options'] = $options;
			$sql['where'] = "trans_id = '{$rs['trans_id']}'";
			parent::_edit($sql);

			if($rs['member_id'] > 0){
				$sql = array();
				$sql['table'] = '@db_member';
				$sql['field']['balance'] = "balance + $amount";
				$sql['where'] = "member_id = '{$rs['member_id']}'";
				parent::_edit($sql);
			}

			$this->wa->mail('payment.succeed', $arr['from_email']);

			if($rs['process']){
				$rs['process'] = preg_replace("/(?|&)trans_id=([^&]*)/i", "", $rs['process']);
				if(strpos($rs['process'], '?') === false){
					$rs['process'] .= "?trans_id={$rs['trans_id']}";
				}else{
					$rs['process'] .= "&trans_id={$rs['trans_id']}";
				}
				$rs['process'] .= '&trans_key='. md5($rs['trans_id'] . SYS_ENCODE_SALT);
				if($_SERVER['REQUEST_METHOD'] == 'POST'){
					header("Location:". $rs['process']);
				}else{
					$redirect = ' (<a href="'. $rs['process'] .'">click here</a>)<meta http-equiv="refresh" content="3; URL='. $rs['process'] .'">';
					$this->wa->showMSG = false;
					$this->wa->setmsg('INFO_PAYMENT_SUCCEED', "{$trans_no}@@@$msg");
					$this->wa->msg[0]['paras'][2] = $redirect;
					$this->wa->putmsg();
				}
			}else{
				$this->wa->setmsg('INFO_PAYMENT_SUCCEED', "{$trans_no}@@@$msg");
			}
		}else{
			$this->wa->setmsg('INFO_PAYMENT_PROCESSED', $trans_no);
		}
	}

	public function fail($trans_no, $msg = ''){
		$sql['table'] = '@db_transaction';
		$sql['field']['status'] = -1;
		$sql['where'][] = "trans_no = '$trans_no'";
		$sql['where'][] = "status = 0";
		parent::_edit($sql);
		$this->wa->setmsg('INFO_PAYMENT_FAIL', "$trans_no@@@$msg");
	}

	public function post($url){
		foreach($_POST as $k => $v){
			$v = urlencode(stripslashes($v));
			$str .= "&$k=$v";
		}
		$str = substr($str, 1);

		$arr = parse_url($url);
		$header .= "POST {$arr['path']} HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded; charset=". SYS_CHARSET ."\r\n";
		$header .= "Content-Length: ". strlen($str) ."\r\n\r\n";

		if($arr['scheme'] == 'https'){
			$fp = fsockopen('ssl://'. $arr['host'], 443, $errno, $errstr, 30);
		}else{
			$fp = fsockopen($arr['host'], 80, $errno, $errstr, 30);
		}

		if(!$fp){
			$this->wa->setmsg('INFO_PAYMENT_FAIL', "[$errno] $errstr");
		}else{
			fwrite($fp, $header .$str);
			return $fp;
		}
	}
}
?>